import xbmc, xbmcaddon, xbmcgui, os
from descriptionparserfactory import *
from util import *

#Create dialog right away so user knows something is happening
dp = xbmcgui.DialogProgress()
dp.create('IARL Wizard','Please Wait...','')
dp.update(0)

addon = xbmcaddon.Addon(id='plugin.program.iarl')
archive_data = get_archive_info()

wizard_data = {'OSX': {'MAME_AKNF_Full': ['RetroArch MAME (Arcade Latest)'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch Mednafen PSX (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['RetroArch Reicast (Dreamcast)'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['FS-UAE Launcher'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['RetroArch FUSE (Spectrum)'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['FS-UAE Launcher'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['FS-UAE Launcher'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['RetroArch Mednafen Saturn (Saturn)'], 'MAME_ZachMorris_Full': ['RetroArch MAME (Arcade Latest)'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['RetroArch MAME 2014 (Arcade 0.159)'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x (SNES Latest)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['RetroArch MAME 2014 (Arcade 0.159)'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['RetroArch FUSE (Spectrum)'], 'Sega_Saturn_ZachMorris_Full': ['RetroArch Mednafen Saturn (Saturn)'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['RetroArch Reicast (Dreamcast)'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'settings': {}, 'Windows': {'MAME_AKNF_Full': ['RetroArch MAME (Arcade Latest)'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch Mednafen PSX (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['RetroArch Reicast (Dreamcast)'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['FS-UAE Launcher'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['RetroArch FUSE (Spectrum)'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['FS-UAE Launcher'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['FS-UAE Launcher'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['RetroArch Mednafen Saturn (Saturn)'], 'MAME_ZachMorris_Full': ['RetroArch MAME (Arcade Latest)'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['RetroArch MAME 2014 (Arcade 0.159)'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x (SNES Latest)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['RetroArch MAME 2014 (Arcade 0.159)'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['RetroArch FUSE (Spectrum)'], 'Sega_Saturn_ZachMorris_Full': ['RetroArch Mednafen Saturn (Saturn)'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['RetroArch Reicast (Dreamcast)'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'LibreElec Remix': {'MAME_AKNF_Full': ['RetroArch MAME (Arcade Latest)'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['Vice (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch Mednafen PSX HW (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch Mednafen PSX HW (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch Mednafen PSX HW (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['RetroArch Reicast (Dreamcast)'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['FS-UAE Launcher'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['RetroArch FUSE (Spectrum)'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['FS-UAE Launcher'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['FS-UAE Launcher'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['Vice (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['RetroArch Mednafen Saturn (Saturn)'], 'MAME_ZachMorris_Full': ['RetroArch MAME (Arcade Latest)'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['RetroArch MAME 2014 (Arcade 0.159)'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x (SNES Latest)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['RetroArch MAME 2014 (Arcade 0.159)'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['RetroArch FUSE (Spectrum)'], 'Sega_Saturn_ZachMorris_Full': ['RetroArch Mednafen Saturn (Saturn)'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['RetroArch Reicast (Dreamcast)'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'Gamestarter Addon': {'MAME_AKNF_Full': ['hidden'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['hidden'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch PCSX ReArmed (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['hidden'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['Gamestarter UAE4ARM Addon (Amiga)'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['hidden'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['Gamestarter UAE4ARM Addon (Amiga)'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['Gamestarter UAE4ARM Addon (Amiga)'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['hidden'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['hidden'], 'MAME_ZachMorris_Full': ['hidden'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['hidden'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['hidden'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['hidden'], 'Sega_Saturn_ZachMorris_Full': ['hidden'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['hidden'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'LibreElec S905 Addon': {'MAME_AKNF_Full': ['hidden'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['hidden'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch PCSX ReArmed (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['hidden'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['RetroArch PUAE (Amiga)'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['hidden'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['RetroArch PUAE (Amiga)'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['RetroArch PUAE (Amiga)'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['hidden'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['hidden'], 'MAME_ZachMorris_Full': ['hidden'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['hidden'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['hidden'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['hidden'], 'Sega_Saturn_ZachMorris_Full': ['hidden'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['hidden'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'LibreElec Sx05RE': {'MAME_AKNF_Full': ['hidden'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['hidden'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch PCSX ReArmed (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['hidden'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['RetroArch PUAE (Amiga)'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['hidden'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['RetroArch PUAE (Amiga)'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['RetroArch PUAE (Amiga)'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['hidden'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['hidden'], 'MAME_ZachMorris_Full': ['hidden'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['hidden'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['hidden'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['hidden'], 'Sega_Saturn_ZachMorris_Full': ['hidden'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['hidden'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'Android': {'MAME_AKNF_Full': ['hidden'], 'Atari_ST_ZachMorris_Full': ['hidden'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch PCSX ReArmed (PS1)'], 'Atari_ST_ZachMorris': ['hidden'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['hidden'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['hidden'], 'PS1_ZachMorris_Full': ['RetroArch PCSX ReArmed (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['hidden'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['RetroArch PUAE (Amiga)'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['RetroArch FUSE (Spectrum)'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['hidden'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Amiga_CD32_Full': ['RetroArch PUAE (Amiga)'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['RetroArch PUAE (Amiga)'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['hidden'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['hidden'], 'MAME_ZachMorris_Full': ['hidden'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['hidden'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x 2010 (SNES 1.52)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['hidden'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['RetroArch FUSE (Spectrum)'], 'Sega_Saturn_ZachMorris_Full': ['hidden'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['hidden'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}, 'Linux/Kodibuntu': {'MAME_AKNF_Full': ['RetroArch MAME (Arcade Latest)'], 'Atari_ST_ZachMorris_Full': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'TG16_Bestof_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Colecovision_ZachMorris_Full': ['RetroArch BlueMSX (MSX)'], 'Point_and_Click_Bestof_ZachMorris': ['RetroArch DOSBox (DOS)'], 'C64_ZachMorris_Full': ['RetroArch VICE C64 (C64)'], 'Master_System_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'PS1_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'PS1_Bestof_ZachMorris': ['RetroArch Mednafen PSX (PS1)'], 'Atari_ST_ZachMorris': ['RetroArch Hatari (Atari ST/STE/TT/Falcon)'], 'Colecovision_ZachMorris': ['RetroArch BlueMSX (MSX)'], 'Genesis_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'GBC_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Game_Gear_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_Bestof_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'x68000_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'Cavestory_Lefty420': ['RetroArch CaveStory (NXEngine)'], 'Master_System_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Apple2GS_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'GB_Classic_Color_Bestof_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'CDI_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)'], 'SNES_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Genesis_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Atari_Jaguar_ZachMorris': ['RetroArch Virtual Jaguar (Jaguar)'], 'PS1_ZachMorris_Full': ['RetroArch Mednafen PSX (PS1)'], 'NES_ZachMorris': ['RetroArch Nestopia (NES)'], 'SNES_Bestof_ZachMorris': ['RetroArch SNES9x (SNES Latest)'], 'Game_and_Watch_ZachMorris': ['RetroArch Game and Watch (Game and Watch)'], 'GBA_ZachMorris_Full': ['RetroArch mGBA (GBA)'], 'N64_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'Atari_7800_ZachMorris': ['RetroArch ProSystem (Atari 7800)'], 'Intellivision_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Sega_Dreamcast_ZachMorris': ['RetroArch Reicast (Dreamcast)'], 'Lutro_ZachMorris': ['RetroArch Lua Engine (Lutro)'], 'x68000_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Dinothawr_Lefty420': ['RetroArch Dinothawr (Standalone Game)'], 'Neo_Geo_CD_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Full_ZachMorris': ['FS-UAE Launcher'], 'GBA_ZachMorris': ['RetroArch mGBA (GBA)'], 'ZX_Spectrum_ZachMorris_Full': ['RetroArch FUSE (Spectrum)'], 'MAME_2003_ZachMorris_Full': ['RetroArch MAME 2003 (Arcade 0.78)'], 'GBC_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], '3DO_ZachMorris': ['RetroArch 4DO (3DO)'], 'Atari_5200_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Magnavox_O2_ZachMorris': ['RetroArch O2EM (Odyssey2/Videopac)'], 'GBA_Bestof_ZachMorris': ['RetroArch mGBA (GBA)'], 'Amiga_CD32_Full': ['FS-UAE Launcher'], 'MAME_2003_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Win31_ZachMorris': ['RetroArch DOSBox (DOS)'], 'CDI_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Amiga_Bestof': ['FS-UAE Launcher'], 'N64_ZachMorris_Full': ['RetroArch ParaLLEl (N64)'], 'Doom_Lefty420': ['RetroArch PrBoom (Doom)'], 'PCE_CD_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'Sega_CD_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'NGPC_ZachMorris_Full': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'Wonderswan_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'EasyRPG_ZachMorris': ['RetroArch EasyRPG (RPG Maker 2000/2003)'], 'MAME_ZachMorris': ['RetroArch MAME (Arcade Latest)'], 'NES_ZachMorris_Full': ['RetroArch Nestopia (NES)'], 'GB_Classic_ZachMorris_Full': ['RetroArch Gambatte (GB/GBC)'], 'FBA_ZachMorris': ['RetroArch FBA (Arcade Latest)'], 'Atari_2600_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SCUMMVM_ZachMorris_Full': ['RetroArch ScummVM (Various)'], 'TG16_ZachMorris': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'C64_ZachMorris': ['RetroArch VICE C64 (C64)'], 'MAME_2003_Bestof_ZachMorris': ['RetroArch MAME 2003 (Arcade 0.78)'], 'Atari_Lynx_ZachMorris': ['RetroArch Handy (Lynx)'], 'FBA_ZachMorris_Full': ['RetroArch FBA (Arcade Latest)'], '32X_ZachMorris': ['RetroArch PicoDrive (SMS/Gen/Sega CD/32X)'], 'Master_System_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'SCUMMVM_ZachMorris': ['RetroArch ScummVM (Various)'], 'Sega_SG1000_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Wonderswan_Color_ZachMorris': ['RetroArch Mednafen Cygne (WonderSwan/WonderSwan Color)'], 'Sega_Saturn_ZachMorris': ['RetroArch Mednafen Saturn (Saturn)'], 'MAME_ZachMorris_Full': ['RetroArch MAME (Arcade Latest)'], 'Game_Gear_ZachMorris_Full': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Sega_SG1000_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'MAME_2014_ZachMorris_Full': ['RetroArch MAME 2014 (Arcade 0.159)'], 'VirtualBoy_ZachMorris': ['RetroArch Mednafen VB (VirtualBoy)'], 'Game_Gear_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'NGPC_ZachMorris': ['RetroArch Mednafen NeoPop (NGP/NGPC)'], 'GB_Classic_ZachMorris': ['RetroArch Gambatte (GB/GBC)'], 'Atari_2600_Bestof_ZachMorris': ['RetroArch Stella (Atari 2600)'], 'SNES_ZachMorris_Full': ['RetroArch SNES9x (SNES Latest)'], 'IA_MSDOS_ZachMorris': ['RetroArch DOSBox (DOS)'], 'MAME_2014_ZachMorris': ['RetroArch MAME 2014 (Arcade 0.159)'], 'Atari_800_ZachMorris': ['RetroArch MESS 2014 (MESS 0.159)'], 'Quake_Lefty420': ['RetroArch TyrQuake (Quake)'], 'NES_Bestof_ZachMorris': ['RetroArch Nestopia (NES)'], 'MAME_CHD_ZachMorris': ['hidden'], 'N64_Bestof_ZachMorris': ['RetroArch ParaLLEl (N64)'], 'TG16_ZachMorris_Full': ['RetroArch Mednafen PCE FAST (PCE/TG16)'], 'ZX_Spectrum_ZachMorris': ['RetroArch FUSE (Spectrum)'], 'Sega_Saturn_ZachMorris_Full': ['RetroArch Mednafen Saturn (Saturn)'], 'MSX_ZachMorris': ['hidden'], 'Sega_Dreamcast_ZachMorris_Full': ['RetroArch Reicast (Dreamcast)'], 'Genesis_Bestof_ZachMorris': ['RetroArch Genesis Plus GX (GG/SMS/Gen/PICO/SG-1000)'], 'Vectrex_ZachMorris': ['RetroArch VECX (Vectrex)'], 'Atari_2600_ZachMorris_Full': ['RetroArch Stella (Atari 2600)'], 'Apple2GS_ZachMorris_Full': ['RetroArch MESS 2014 (MESS 0.159)']}}
wizard_data['settings'] = { 'iarl_external_user_external_env' : addon.getSetting('iarl_external_user_external_env'),
							'iarl_external_user_external_env_options' : 'OSX|Linux/Kodibuntu|Windows|LibreElec Remix|LibreElec Sx05RE|LibreElec S905 Addon|Gamestarter Addon|Android'.split('|'),
							'iarl_external_launch_close_kodi' : addon.getSetting('iarl_external_launch_close_kodi'),
							'iarl_path_to_retroarch' : addon.getSetting('iarl_path_to_retroarch'),
							'iarl_path_to_retroarch_system_dir' : addon.getSetting('iarl_path_to_retroarch_system_dir'),
							'iarl_path_to_retroarch_cfg' : addon.getSetting('iarl_path_to_retroarch_cfg'),
							'iarl_additional_emulator_1_type' : addon.getSetting('iarl_additional_emulator_1_type'),
							'iarl_additional_emulator_1_path' : addon.getSetting('iarl_additional_emulator_1_path'),
							'iarl_additional_emulator_2_type' : addon.getSetting('iarl_additional_emulator_2_type'),
							'iarl_additional_emulator_2_path' : addon.getSetting('iarl_additional_emulator_2_path'),
							'iarl_wizard_launcher' : addon.getSetting('iarl_wizard_launcher')}

possible_retroarch_app_locations = [os.path.join('Applications','RetroArch.app','Contents','MacOS','RetroArch'),os.path.join('usr','bin','retroarch'),os.path.join('C:','Program Files (x86)','Retroarch','retroarch.exe')]
possible_retroarch_config_locations = [os.path.join('mnt','internal_sd','Android','data','com.retroarch','files','retroarch.cfg'),os.path.join('sdcard','Android','data','com.retroarch','files','retroarch.cfg'),os.path.join('data','data','com.retroarch','retroarch.cfg'),os.path.join('data','data','com.retroarch','files','retroarch.cfg')]
#possible_retroarch_system_folder_locations = [os.path.join('storage','emulated','0','RetroArch','system'),os.path.join('XXXUSERDIRXXX','Documents','RetroArch','system'),os.path.join('C:','Program Files (x86)','Retroarch','system')]
#Rep XXXUSERDIRXXX with os.path.join(os.environ['HOME']
try:
	parserfile = os.path.join(addon.getAddonInfo('path'),'resources','data','external_launcher_parser.xml')
	launchersfile = os.path.join(addon.getAddonInfo('path'),'resources','data','external_command_database.xml')
	descParser = DescriptionParserFactory.getParser(parserfile)
	results = descParser.parseDescription(launchersfile,'xml')
except:
	xbmc.log(msg='IARL:  Wizard could not find the external launch database.', level=xbmc.LOGDEBUG)
# print results[0]

current_dialog = xbmcgui.Dialog()
not_ready = False
not_ready_reason = 'See Debug Log.'


if not not_ready:
	if 'Select' in wizard_data['settings']['iarl_external_user_external_env'] and 'External' in wizard_data['settings']['iarl_wizard_launcher']:
		ret1 = current_dialog.select('Select your system type', wizard_data['settings']['iarl_external_user_external_env_options'])
		if ret1>-1:
			addon.setSetting('iarl_external_user_external_env',wizard_data['settings']['iarl_external_user_external_env_options'][ret1])
			xbmc.log(msg='IARL:  Wizard updated system type to '+wizard_data['settings']['iarl_external_user_external_env_options'][ret1], level=xbmc.LOGNOTICE)
			wizard_data['settings']['iarl_external_user_external_env'] = wizard_data['settings']['iarl_external_user_external_env_options'][ret1]
		else:
			not_ready_reason = 'Please select your system type in addon settings'
			not_ready = True

if not not_ready:
	if 'OSX' in wizard_data['settings']['iarl_external_user_external_env'] or 'Windows' in wizard_data['settings']['iarl_external_user_external_env'] or 'Linux/Kodibuntu' in wizard_data['settings']['iarl_external_user_external_env']:
		if len(wizard_data['settings']['iarl_path_to_retroarch'])<1 and 'RetroPlayer' not in wizard_data['settings']['iarl_wizard_launcher']:
			app_found_idx = None
			dialog_for_app_path = False
			for jj in range(0,len(possible_retroarch_app_locations)):
				try:
					if os.path.isfile(possible_retroarch_app_locations[jj]):
						app_found_idx = jj
				except:
					pass
			if app_found_idx is not None:
				ret1 = current_dialog.select('Is this path correct for your retroarch installation?[CR]'+str(possible_retroarch_app_locations[app_found_idx]), ['Yes','No'])
				if ret1==0:
					addon.setSetting('iarl_path_to_retroarch',possible_retroarch_app_locations[app_found_idx])
					xbmc.log(msg='IARL:  Wizard updated retroarch path to '+str(possible_retroarch_app_locations[app_found_idx]), level=xbmc.LOGNOTICE)
					wizard_data['settings']['iarl_path_to_retroarch'] = possible_retroarch_app_locations[app_found_idx]
				else:
					dialog_for_app_path = True
			else:
				dialog_for_app_path = True
			if dialog_for_app_path:
				new_path = current_dialog.browse(1,'RetroArch App Location','files')
				if len(new_path)>0:
					addon.setSetting('iarl_path_to_retroarch',new_path)
					xbmc.log(msg='IARL:  Wizard updated retroarch path to '+str(new_path), level=xbmc.LOGNOTICE)
					wizard_data['settings']['iarl_path_to_retroarch'] = new_path
				else:
					not_ready_reason = 'Path to retroarch must be set first.'
					not_ready = True
if not not_ready:
	if len(wizard_data['settings']['iarl_path_to_retroarch_system_dir'])<1 and 'RetroPlayer' not in wizard_data['settings']['iarl_wizard_launcher']:
		dialog_for_dir_path = False
		ret1 = current_dialog.select('Do you want to locate your Retroarch system directory?[CR]This is required to play some systems.', ['Yes','No'])
		if ret1<1:
			dialog_for_dir_path = True
		else:
			dialog_for_dir_path = False
		if dialog_for_dir_path:
			new_dir_path = current_dialog.browse(0,'RetroArch System Directory Location','files')
			if len(new_dir_path)>0:
				addon.setSetting('iarl_path_to_retroarch_system_dir',new_dir_path)
				xbmc.log(msg='IARL:  Wizard updated retroarch system directory path to '+str(new_dir_path), level=xbmc.LOGNOTICE)
				wizard_data['settings']['iarl_path_to_retroarch_system_dir'] = new_dir_path
			else:
				xbmc.log(msg='IARL:  Wizard did not update the retroarch system directory, continuing.', level=xbmc.LOGNOTICE)
if not not_ready:
	if 'Android' in wizard_data['settings']['iarl_external_user_external_env']:
		if len(wizard_data['settings']['iarl_path_to_retroarch_cfg'])<1 and 'RetroPlayer' not in wizard_data['settings']['iarl_wizard_launcher']:
			cfg_found_idx = None
			dialog_for_cfg_path = False
			for jj in range(0,len(possible_retroarch_config_locations)):
				try:
					if os.path.isfile(possible_retroarch_config_locations[jj]):
						cfg_found_idx = jj
				except:
					pass
			if cfg_found_idx is not None:
				ret1 = current_dialog.select('Is this path correct for your retroarch config file?[CR]'+str(possible_retroarch_config_locations[cfg_found_idx]), ['Yes','No'])
				if ret1==0:
					addon.setSetting('iarl_path_to_retroarch_cfg',possible_retroarch_config_locations[cfg_found_idx])
					xbmc.log(msg='IARL:  Wizard updated retroarch config path to '+str(possible_retroarch_config_locations[cfg_found_idx]), level=xbmc.LOGNOTICE)
					wizard_data['settings']['iarl_path_to_retroarch_cfg'] = possible_retroarch_config_locations[cfg_found_idx]
				else:
					dialog_for_cfg_path = True
			else:
				dialog_for_cfg_path = True
			if dialog_for_cfg_path:
				new_config_path = current_dialog.browse(1,'RetroArch Configuration File Location','files')
				if len(new_config_path)>0:
					addon.setSetting('iarl_path_to_retroarch_cfg',new_config_path)
					xbmc.log(msg='IARL:  Wizard updated retroarch cfg path to '+str(new_config_path), level=xbmc.LOGNOTICE)
					wizard_data['settings']['iarl_path_to_retroarch'] = new_config_path
				else:
					xbmc.log(msg='IARL:  Wizard did not update the retroarch config file location, continuing.', level=xbmc.LOGNOTICE)

#Main script start
if not not_ready:
	xbmc.log(msg='IARL:  Wizard attempting to initialize userdata', level=xbmc.LOGDEBUG)
	try:
		initialize_userdata()
	except:
		xbmc.log(msg='IARL:  Unable to initialize userdata', level=xbmc.LOGERROR)
	if 'External' in wizard_data['settings']['iarl_wizard_launcher']:
		user_options = list()
		launch_command = list()
		new_launch_command = None
		xbmc.log(msg='IARL:  Wizard Script Started for external launching', level=xbmc.LOGNOTICE)
		if 'enabled' in wizard_data['settings']['iarl_external_launch_close_kodi'].lower():
			external_launch_database_os = wizard_data['settings']['iarl_external_user_external_env'] + ' Close_Kodi' #Look for launch commands to close Kodi
		else:
			external_launch_database_os = wizard_data['settings']['iarl_external_user_external_env']
		if wizard_data['settings']['iarl_external_user_external_env'] in 'LibreElec Remix|LibreElec Sx05RE|LibreElec S905 Addon|Gamestarter Addon|Android'.split('|'):
			external_launch_database_os = external_launch_database_os.replace(' Close_Kodi','') #By default, the above setups auto close Kodi, so there's only one list of launchers to choose from
		
		for entries in results:
			#Define the list of commands from the external database corresponding to the current environment
			if entries['operating_system'][0] == external_launch_database_os:
				user_options.append(entries['launcher'][0])
				launch_command.append(entries['launcher_command'][0])

		# initialize_userdata()
		userdata_xmldir = get_userdata_xmldir()
		userdata_subfolders, userdata_files = xbmcvfs.listdir(userdata_xmldir)

		dp = xbmcgui.DialogProgress()
		dp.create('IARL Wizard','Updating Settings','')
		dp.update(0)
		for ffiles in userdata_files:
			try:
				current_name = os.path.splitext(os.path.split(ffiles)[-1])[0]
			except:
				current_name = None
				xbmc.log(msg='IARL:  '+str(current_name)+' could not be found', level=xbmc.LOGDEBUG)
			try:
				current_key = wizard_data[wizard_data['settings']['iarl_external_user_external_env']][current_name][0]
			except:
				current_key = None
				xbmc.log(msg='IARL:  Wizard setting for '+str(current_name)+' for environment '+wizard_data['settings']['iarl_external_user_external_env']+' could not be found', level=xbmc.LOGDEBUG)

			if current_key is not None:
				# print launch_command[user_options.index(current_key)]
				percent_complete = int((int(userdata_files.index(ffiles))*100)/int(len(userdata_files)))
				dp.update(percent_complete)
				xbmc.sleep(100)
				if dp.iscanceled():
					dp.close()
					raise
				if 'hidden' in current_key:
					try:
						arch_idx = archive_data['category_id'].index(current_name)
						current_emu_category = archive_data['emu_category'][arch_idx]
						if 'hidden' not in current_emu_category:
							new_xml_category = current_emu_category + ', hidden'
							update_xml_header(userdata_xmldir,ffiles,'emu_category',new_xml_category)
							xbmc.log(msg='IARL:  The listing for '+str(ffiles)+' was hidden with the Wizard', level=xbmc.LOGDEBUG)
						else:
							xbmc.log(msg='IARL:  The listing for '+str(ffiles)+' is already hidden', level=xbmc.LOGDEBUG)
					except:
						xbmc.log(msg='IARL:  The listing for '+str(ffiles)+' could not be hidden with the Wizard', level=xbmc.LOGDEBUG)
				else:
					try:
						update_xml_header(userdata_xmldir,ffiles,'emu_launcher','external')
					except:
						xbmc.log(msg='IARL:  emu_launcher command for '+str(ffiles)+' could not be set in Wizard', level=xbmc.LOGDEBUG)
					try:
						update_xml_header(userdata_xmldir,ffiles,'emu_ext_launch_cmd',launch_command[user_options.index(current_key)])
						xbmc.log(msg='IARL:  '+str(ffiles)+' new command: '+str(launch_command[user_options.index(current_key)]), level=xbmc.LOGDEBUG)
					except:
						xbmc.log(msg='IARL:  emu_ext_launch_cmd for '+str(ffiles)+' could not be set in Wizard', level=xbmc.LOGDEBUG)
	else: #Retroplayer Launching selected
		xbmc.log(msg='IARL:  Wizard Script Started for RetroPlayer launching', level=xbmc.LOGNOTICE)

		# initialize_userdata()
		userdata_xmldir = get_userdata_xmldir()
		userdata_subfolders, userdata_files = xbmcvfs.listdir(userdata_xmldir)

		dp = xbmcgui.DialogProgress()
		dp.create('IARL Wizard','Updating Settings','')
		dp.update(0)
		for ffiles in userdata_files:
			percent_complete = int((int(userdata_files.index(ffiles))*100)/int(len(userdata_files)))
			dp.update(percent_complete)
			xbmc.sleep(100)
			if dp.iscanceled():
				dp.close()
				raise
			try:
				update_xml_header(userdata_xmldir,ffiles,'emu_launcher','retroplayer')
			except:
				xbmc.log(msg='IARL:  emu_launcher command for '+str(ffiles)+' could not be set in Wizard', level=xbmc.LOGDEBUG)

	clear_userdata_list_cache_dir()
	dp.close()
	ok_ret = current_dialog.ok('Complete','Wizard run completed!')
	xbmc.log(msg='IARL:  Wizard Script Completed', level=xbmc.LOGNOTICE)
else:
	xbmc.log(msg='IARL:  Wizard Script Cancelled or Setup Not Ready', level=xbmc.LOGNOTICE)
	xbmc.log(msg='IARL:  W_Setting Ext Env:  '+str(wizard_data['settings']['iarl_external_user_external_env']), level=xbmc.LOGDEBUG)
	xbmc.log(msg='IARL:  W_Setting Close Kodi:  '+str(wizard_data['settings']['iarl_external_launch_close_kodi']), level=xbmc.LOGDEBUG)
	xbmc.log(msg='IARL:  W_Setting RA Path:  '+str(wizard_data['settings']['iarl_path_to_retroarch']), level=xbmc.LOGDEBUG)
	xbmc.log(msg='IARL:  W_Setting RA CFG Path:  '+str(wizard_data['settings']['iarl_path_to_retroarch_cfg']), level=xbmc.LOGDEBUG)
	xbmc.log(msg='IARL:  W_Setting Launcher:  '+str(wizard_data['settings']['iarl_wizard_launcher']), level=xbmc.LOGDEBUG)
	dp.close()
	ok_ret = current_dialog.ok('Setup not ready',not_ready_reason)